#pragma once
#include "BitmapHyperLink.h"
#pragma comment(lib, "version.lib")
//-------------------------------------------------------------
// AboutBox 
//-------------------------------------------------------------
class CAboutDlg : public  CDialogImpl<CAboutDlg> 
{
public:
	enum { IDD = IDD_ABOUTBOX };

	CBitmapHyperLink m_ctlLink;

	BEGIN_MSG_MAP(CAboutDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		DWORD   dwVerInfoSize;
		char    *pstrVerInfo;
		UINT    intSize;
		CHAR    strProgName[MAX_PATH];
		PCHAR   pstrFileDescription;
		PCHAR   pstrFileVersion;
		PCHAR   pstrLegalCopyright;

		::GetModuleFileName ( _Module.GetResourceInstance() , strProgName , sizeof(strProgName)); 
		dwVerInfoSize = ::GetFileVersionInfoSize ( strProgName , 0 );
		pstrVerInfo = new char[dwVerInfoSize];
		::GetFileVersionInfo ( strProgName , 0 , dwVerInfoSize , pstrVerInfo );

		VerQueryValue ( pstrVerInfo , "\\StringFileInfo\\041104b0\\FileDescription" , (PVOID *)&pstrFileDescription , &intSize );
		VerQueryValue ( pstrVerInfo , "\\StringFileInfo\\041104b0\\FileVersion" , (PVOID *)&pstrFileVersion , &intSize );

		CString strBuf;
		strBuf.Format ( "%s Version %s" , pstrFileDescription , pstrFileVersion );
		SetDlgItemText ( IDC_ABOUT_VERSION , strBuf );

		VerQueryValue ( pstrVerInfo , "\\StringFileInfo\\041104b0\\LegalCopyright" , (PVOID *)&pstrLegalCopyright , &intSize );
		SetDlgItemText ( IDC_ABOUT_COPYRIGHT , pstrLegalCopyright );

        m_ctlLink.SubclassWindow(GetDlgItem(IDC_STATIC_LINK));
        m_ctlLink.SetLabel(_T("http://www.geocities.jp/helohelo2004/"));
        m_ctlLink.SetHyperLink(_T("http://www.geocities.jp/helohelo2004/"));
		m_ctlLink.SetExtendedStyle(HLINK_RIGHTIMAGE);
		m_ctlLink.SetLinkColor(RGB(0, 0, 0));
		m_ctlLink.SetVisitedColor(RGB(0, 255, 255));
		m_ctlLink.SetHoverColor(RGB(0, 0, 255));
		HBITMAP hBmp = m_ctlLink.AddBitmap(IDB_ARROW);
		ATLASSERT(hBmp);

		CenterWindow(GetParent());

		return TRUE;
	}

	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}
};
