#pragma once

#define			TIMER_ID_WINDOW_OPEN					1			
#define			TIMER_ID_WINDOW_CLOSE					2
#define			TIMER_ID_HTTP_ACCESS					3
#define			TIMER_ID_CHECK_SHIFT_KEY				4

#define         POPUPWINDOW_WIDTH						315	
//#define         POPUPWINDOW_HEIGHT						125	

//******************************************************************************
// CBasicAuthF
//
//******************************************************************************
class CBasicAuth : public CBasicAuthObject, public IAuthInfo
{
public:
    void SetUserPass ( const CString &strUser , const CString &strPass )
	{
		m_strUserID   = strUser;
		m_strPassword = strPass;
	}
private:
    void Init(CAtlHttpClient *pSocket, IAuthInfo *pAuthInfo)
    {
        CBasicAuthObject::Init( pSocket, pAuthInfo );
    }
     bool Authenticate(LPCTSTR szAuthTypes, bool bProxy)
    {
		if (bProxy = TRUE ) {							//?PROXY F
	        return CBasicAuthObject::Authenticate( szAuthTypes, bProxy );
		}
		else {
			return FALSE;
		}
	}

    HRESULT GetPassword(LPTSTR szPwd, DWORD* dwBuffSize)
    {
        if (CopyCString( m_strPassword, szPwd, dwBuffSize ))
            return S_OK;

        return E_FAIL;
    }

    HRESULT GetUsername(LPTSTR szUid, DWORD* dwBuffSize)
    {
        if (CopyCString( m_strUserID, szUid, dwBuffSize ))
            return S_OK;

        return E_FAIL;
    }
    HRESULT GetDomain(LPTSTR szDomain, DWORD* dwBuffSize)
    {
        ATLASSERT(false);
        return S_OK;
    }

    CString m_strUserID;
    CString m_strPassword;
};
#define WM_FORCE_UPDATE				WM_USER+100

//******************************************************************************
// |bvAbv
//
//******************************************************************************
class CPopupMon : public CFrameWindowImpl <CPopupMon> , public CMessageFilter , public CIdleHandler
{
private:
	LONG  mlngHeight;
//    CRect mrcWinRect;
	CRect mrcDeskTop;
	CSize mszDeskTop;

	long mlngPopupWindowWidth;									//EBhE
	long mlngPoopupWindowHeight;                               //EBhE

	BOOL        m_DoPopupOpenClose;
	CUrl        m_clsTargetURL;									//ڑURL

//	CPopupMonView  m_view;										// View

	CMainFrameInterface *m_pclsFrame;							// eEBhE	
	CXRateInfoItems     m_clsRateItems;                         // \

	CString				m_strOwnMessage;						// ʂɏoBTCYȌꍇ́A[g\
	CFont				m_clsFont;								// tHg
	CSize				m_clsCharSize;						    // ꕶ傫
	int					m_intDateRowCount;						// ts
	int					m_intBodyRowCount;						// {fBs
// Color
	CBrush				m_clsColorBodyBack;						//{̔wiF
	CBrush				m_clsColorHeaderBack;					//wb_[wiF
	CBrush				m_clsColorDateBack;						//twiF
	CBrush				m_clsColorRateUpBack;					//RateUpwiF
	CBrush				m_clsColorRateDownBack;					//RateDownwiF

public:
	DECLARE_FRAME_WND_CLASS(NULL, NULL)

	BEGIN_MSG_MAP(CPopupMon)
		MESSAGE_HANDLER(WM_CREATE  , OnCreate    )
		MESSAGE_HANDLER(WM_TIMER   , OnTimer     )
		MESSAGE_HANDLER(WM_DESTROY , OnDestroy   )
		MESSAGE_HANDLER(WM_PAINT   , OnPaint     )
		MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
		MESSAGE_HANDLER(WM_LBUTTONUP  , OnLButtonUp  )
		MESSAGE_HANDLER(WM_MOUSEMOVE  , OnMouseMove  )
		MESSAGE_HANDLER(WM_ERASEBKGND , OnEraseBackGround)
		MESSAGE_HANDLER(WM_FORCE_UPDATE , OnForceUpdate )
		CHAIN_MSG_MAP(CFrameWindowImpl<CPopupMon>)
	END_MSG_MAP()

	volatile BOOL		m_HttpAccessInProgress;
	BOOL				g_blnActivate;

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

    LRESULT MonitorCreate ( CMainFrameInterface *pclsParentFrameWnd )
	{
		DWORD dwStyle;
		m_pclsFrame = pclsParentFrameWnd;

		if ( m_pclsFrame->GetParameter()->m_blnRateWindowAlwaysTop && 
			m_pclsFrame->GetParameter()->m_intAlpha > 0 ) {     //?ɎOɕ\
			dwStyle = WS_EX_TRANSPARENT;						 //ߑ
		}
		else {
			dwStyle =0;
		}
		Create ( pclsParentFrameWnd->GethWnd() ,CWindow::rcDefault , _T("GaitameMon") , 
						WS_POPUP       | WS_VISIBLE , WS_EX_NOACTIVATE | WS_EX_LAYERED | dwStyle );
		ShowWindow (SW_HIDE );
		UpdateWindow();
//		mrcWinRect.SetRectEmpty ();
		return 0;
	}
	LRESULT MonitorClose()
	{
		if (m_DoPopupOpenClose) {				//?s
			return 0;
		}
		if (IsWindowVisible() ) {
			GetWindowRect ( &m_pclsFrame->GetParameter()->m_clsRectRateWindow );
			SetTimer ( TIMER_ID_WINDOW_CLOSE , 5 );
			m_DoPopupOpenClose = TRUE;
			KillTimer ( TIMER_ID_CHECK_SHIFT_KEY );
		}
		return 0;
	}
	LRESULT MonitorOpen ()
	{
		CRect *pclsRectRateWindow;
		if (m_DoPopupOpenClose) {				//?s
			return 0;
		}
		if (!IsWindowVisible() ) {
			OnChangeAlpha ( m_pclsFrame->GetParameter()->m_intAlpha , m_pclsFrame->GetParameter()->m_blnUseColorKey);								//xݒ
			::SystemParametersInfo(SPI_GETWORKAREA, NULL, &mrcDeskTop, NULL);     //fBXNgbvTCY擾
			mszDeskTop = mrcDeskTop.Size ();
			mlngHeight = 0;													// EBhE

			pclsRectRateWindow = &m_pclsFrame->GetParameter()->m_clsRectRateWindow;
			if ( pclsRectRateWindow->IsRectEmpty () ) {
				pclsRectRateWindow->left   = mrcDeskTop.left + ( mszDeskTop.cx - mlngPopupWindowWidth );
				pclsRectRateWindow->right  = pclsRectRateWindow->left + mlngPopupWindowWidth;
				switch (m_pclsFrame->GetParameter()->m_enmPopupGrow) {
				case POPUP_GROW_DIR_BOTTOM_TO_TOP:								//
					pclsRectRateWindow->top    = mrcDeskTop.top  + mszDeskTop.cy;
					pclsRectRateWindow->bottom = pclsRectRateWindow->top;
					break;
				case POPUP_GROW_DIR_TOP_TO_BOTTOM:								//ォ牺
					pclsRectRateWindow->top    = mrcDeskTop.top;
					pclsRectRateWindow->bottom = pclsRectRateWindow->top;
					break;
				}
			}
			else {
				switch (m_pclsFrame->GetParameter()->m_enmPopupGrow) {
				case POPUP_GROW_DIR_BOTTOM_TO_TOP:								//
					pclsRectRateWindow->top = pclsRectRateWindow->bottom;
					break;
				case POPUP_GROW_DIR_TOP_TO_BOTTOM:								//ォ牺
					pclsRectRateWindow->bottom = pclsRectRateWindow->top;
					break;
				}
			}
			SetForegroundWindow( m_hWnd );
			ShowWindow (SW_SHOW );
			MoveWindow  ( pclsRectRateWindow , TRUE );
			SetTimer ( TIMER_ID_WINDOW_OPEN , 0 );
			if (!m_HttpAccessInProgress) {			//?httpNGXgłȂƂ
				SetTimer ( TIMER_ID_HTTP_ACCESS , 10 );                             // 
			}
			m_DoPopupOpenClose = TRUE;
			SetTimer ( TIMER_ID_CHECK_SHIFT_KEY , 100 );							// SHIFTL[`FbNp^C}[
		}
		return 0;
	}
	LRESULT MonitorDestroy()
	{
		if (IsWindowVisible()) {													//?EBhEJĂƂTCYۑ
			GetWindowRect ( &m_pclsFrame->GetParameter()->m_clsRectRateWindow );
		}
		DestroyWindow();
		return 0;
	}

	void PauseHttpAccess( BOOL blnPause )
	{
		DWORD  dwInterval;
		if (blnPause) {
			KillTimer	( TIMER_ID_HTTP_ACCESS  );
			KillTimer   ( TIMER_ID_CHECK_SHIFT_KEY );							// SHIFTL[`FbNp^C}[
		}
		else {
			if (IsWindowVisible() ) {
				dwInterval = m_pclsFrame->GetParameter()->m_intIntervalTimeOnDisplay * 1000;
			}
			else {
				dwInterval = m_pclsFrame->GetParameter()->m_intIntervalTimeOnHidden * 1000;
			}
			if ( dwInterval > 0 ) {                                         // ƂANZXĂȂ:^C}[ғ
				SetTimer	( TIMER_ID_HTTP_ACCESS , dwInterval ); 
			}
			SetTimer ( TIMER_ID_CHECK_SHIFT_KEY , 100 );							// SHIFTL[`FbNp^C}[
		}
	}
	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		if(CFrameWindowImpl<CPopupMon>::PreTranslateMessage(pMsg))
			return TRUE;
		return FALSE;
//		return m_view.PreTranslateMessage(pMsg);
	}
	virtual BOOL OnIdle()
	{
		return FALSE;
	}
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
//		m_hWndClient = m_view.Create ( m_hWnd );

		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		if ( m_pclsFrame->GetParameter()->m_blnRateWindowAlwaysTop ) {       //?őOʕ\
			SetWindowPos ( HWND_TOPMOST , 0 , 0 , 0 , 0 , SWP_NOMOVE | SWP_NOSIZE );
		}
		else {
			SetWindowPos ( HWND_TOP     , 0 , 0 , 0 , 0 , SWP_NOMOVE | SWP_NOSIZE );
		}
		m_HttpAccessInProgress = FALSE;
		m_DoPopupOpenClose = FALSE;
		m_clsFont.CreatePointFont ( 90 , _T("lr SVbN") );
//		m_intDateRowCount = 1;
		m_intBodyRowCount = RATEITEM_COUNTS;

		m_clsRateItems.SetParameter ( m_pclsFrame->GetParameter()->m_tblClock );    // [gꗗɎݒ
		m_intDateRowCount =  m_clsRateItems.gtblClock.GetCount() ;
		m_clsTargetURL.CrackUrl ( _T("http://www.gaitame.com/rate/rate.asp") );

		CClientDC  clsDC(*this);
		HFONT hSavedFont = clsDC.SelectFont ( m_clsFont );
		clsDC.GetTextExtent ( _T("A") , -1 , &m_clsCharSize );                   // eLXg̎擾
		clsDC.SelectFont ( hSavedFont );

		mlngPopupWindowWidth   = POPUPWINDOW_WIDTH;
		mlngPoopupWindowHeight = ( 1 + m_pclsFrame->GetParameter()->m_intRateDisplayCount +
										m_intDateRowCount ) * m_clsCharSize.cy + 4; 

		m_clsColorBodyBack.CreateSolidBrush(m_pclsFrame->GetParameter()->m_ColorBodyBack);
		m_clsColorDateBack.CreateSolidBrush(m_pclsFrame->GetParameter()->m_ColorDateBack);
		m_clsColorHeaderBack.CreateSolidBrush(m_pclsFrame->GetParameter()->m_ColorHeaderBack);
		m_clsColorRateUpBack.CreateSolidBrush(m_pclsFrame->GetParameter()->m_ColorRateUpBack);
		m_clsColorRateDownBack.CreateSolidBrush(m_pclsFrame->GetParameter()->m_ColorRateDownBack);

		DWORD  dwInterval;
		dwInterval = m_pclsFrame->GetParameter()->m_intIntervalTimeOnHidden * 1000;
		if ( dwInterval > 0 ) {                                         // ƂANZXĂȂ:^C}[ғ
			SetTimer	( TIMER_ID_HTTP_ACCESS , dwInterval ); 
		}

		return 0;
	}
	//
	// ݒʂ̓xݒ
	//
	void    OnChangeAlpha ( 
							int intAlpha	,				//x:0(񓧖)`100()
							BOOL blnUseColorKey				// ߃J[w(t{̔wiF)
							)
	{
		if (blnUseColorKey) {
			SetLayeredWindowAttributes ( m_hWnd , m_pclsFrame->GetParameter()->m_ColorBodyBack , (BYTE)((100-intAlpha) * 255L / 100L) , LWA_ALPHA | LWA_COLORKEY);
		}
		else {
			SetLayeredWindowAttributes ( m_hWnd , 0 , (BYTE)((100-intAlpha) * 255L / 100L) , LWA_ALPHA );
		}
	}
	LRESULT OnSysCommand(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
	{
		switch (wParam) 
		{
		case SC_CLOSE:												// ~{^
			SetTimer ( TIMER_ID_WINDOW_CLOSE , 10 );
			m_DoPopupOpenClose = TRUE;
			bHandled = TRUE;
			break;
		default:
			bHandled = FALSE;
			break;
		}
		return 0;
	}
	LRESULT OnDestroy (UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		m_clsFont.DeleteObject ();
		m_clsColorBodyBack.DeleteObject ();
		m_clsColorDateBack.DeleteObject ();
		m_clsColorHeaderBack.DeleteObject ();
		m_clsColorRateUpBack.DeleteObject ();
		m_clsColorRateDownBack.DeleteObject ();

		KillTimer ( TIMER_ID_WINDOW_OPEN );
		KillTimer ( TIMER_ID_WINDOW_CLOSE );
		KillTimer ( TIMER_ID_HTTP_ACCESS );
		bHandled = FALSE;
		return 0;
	}
	static bool WINAPI HttpNavCallback(DWORD bytes, DWORD objPtr)
	{
		CPopupMon* thisObj = reinterpret_cast <CPopupMon *>(objPtr); //g_thisPopupWnd;
		ATLASSERT(thisObj);

		MSG msg;
		while (::PeekMessage( &msg , NULL, NULL, NULL, PM_REMOVE ))
		{
			::TranslateMessage( &msg );
			::DispatchMessage( &msg );
		} 
		return TRUE;
	}
	static bool WINAPI HttpChunkCallback(BYTE **ppData , DWORD *pdwSize , DWORD_PTR objPtr)
	{
		CPopupMon* thisObj = reinterpret_cast <CPopupMon *>(objPtr); //g_thisPopupWnd;
		ATLASSERT(thisObj);

		MSG msg;
		while (::PeekMessage( &msg , NULL, NULL, NULL, PM_REMOVE ))
		{
			::TranslateMessage( &msg );
			::DispatchMessage( &msg );
		} 
		return TRUE;
	}


	LRESULT OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{
		DWORD dwInterval;
		CRect rcPopup;
		SHORT intKeyState;

		GetWindowRect ( &rcPopup);
		switch (wParam)
		{
		case TIMER_ID_WINDOW_OPEN:
		case TIMER_ID_WINDOW_CLOSE:
			if (wParam == TIMER_ID_WINDOW_OPEN ) {								// JƂ
				mlngHeight += 4;
				if (mlngHeight >= mlngPoopupWindowHeight ) {
					KillTimer ( TIMER_ID_WINDOW_OPEN );
					m_DoPopupOpenClose = FALSE;
					mlngHeight = mlngPoopupWindowHeight;
				}
			}
			else {																// Ƃ
				mlngHeight -= 4;
				if (mlngHeight <= 0 ) {
					KillTimer ( TIMER_ID_WINDOW_CLOSE );
					ShowWindow ( SW_HIDE );
					m_DoPopupOpenClose = FALSE;
					mlngHeight = 0;
				}
			}
			switch (m_pclsFrame->GetParameter()->m_enmPopupGrow) {
			case POPUP_GROW_DIR_BOTTOM_TO_TOP:								//
				rcPopup.top    = rcPopup.bottom - mlngHeight;
				break;
			case POPUP_GROW_DIR_TOP_TO_BOTTOM:								//ォ牺
				rcPopup.bottom = rcPopup.top    + mlngHeight;
				break;
			}
			InvalidateRect(NULL);
			MoveWindow  ( rcPopup , TRUE );
			break;
		case TIMER_ID_HTTP_ACCESS:
			KillTimer	( TIMER_ID_HTTP_ACCESS );
			HttpAccess( );

			if ( IsWindowVisible() ) {                             //?ʕ\
				dwInterval = m_pclsFrame->GetParameter()->m_intIntervalTimeOnDisplay * 1000;
				SetTimer	( TIMER_ID_HTTP_ACCESS , dwInterval ); 
			}
			else {													//?ĂƂ
				dwInterval = m_pclsFrame->GetParameter()->m_intIntervalTimeOnHidden * 1000;
				if ( dwInterval > 0 ) {
					SetTimer	( TIMER_ID_HTTP_ACCESS , dwInterval ); 
				}
			}
			break;
		case TIMER_ID_CHECK_SHIFT_KEY:								// SHIFTKEY CHECK
			if ( m_pclsFrame->GetParameter()->m_blnUseColorKey ) {				//?߃J[L[w肠
				CPoint clsMousePos;
				GetCursorPos ( &clsMousePos );
				intKeyState =  (GetKeyState  ( VK_SHIFT ) & GetKeyState  ( VK_CONTROL ));  // SHIFT & Ctrl
				if ((intKeyState & 0x8000) && rcPopup.PtInRect ( clsMousePos )) {	//?}EXJ[\EBhE̒
					OnChangeAlpha ( m_pclsFrame->GetParameter()->m_intAlpha , FALSE );	//ꎞIɉ
				}
				else {
					OnChangeAlpha ( m_pclsFrame->GetParameter()->m_intAlpha , TRUE  );	//
				}
			}
			if ( m_pclsFrame->GetParameter()->m_blnRateWindowAlwaysTop && 
				m_pclsFrame->GetParameter()->m_intAlpha >0 ) {     //?ɎOɕ\
				intKeyState =  GetKeyState  ( VK_SHIFT );
				DWORD dwStyle;
				dwStyle = GetWindowLong ( GWL_EXSTYLE );
				if (intKeyState & 0x8000 ) {								//?SHIFT KEY
					SetWindowLong( GWL_EXSTYLE , dwStyle & (~WS_EX_TRANSPARENT));
				}
				else {
					SetWindowLong( GWL_EXSTYLE , dwStyle | WS_EX_TRANSPARENT);
				}
			}
		default:
			break;
		}
		return 0;
	}
	//
	// HttpAccess
	//
	void HttpAccess  ()
	{
		unsigned lngThreadID;
		HANDLE   hHttpThread;

		if (!m_HttpAccessInProgress) {
			hHttpThread = (HANDLE)_beginthreadex ( NULL , 0 , &HttpAccessThread , this , 0 , &lngThreadID );
			CloseHandle ( hHttpThread );
		}
	}
	static unsigned __stdcall HttpAccessThread (void *pclsargPopupMon)
	{
		CString str;
		CBasicAuth basicAuth;
		CAtlHttpClient  *pclsHttpClient;							// HTTPClient
		CAtlNavigateData clsNavData;
		CPopupMon		*pclsPopupMon = reinterpret_cast <CPopupMon *>(pclsargPopupMon);

		pclsPopupMon->m_HttpAccessInProgress = TRUE;				//s

		pclsHttpClient = new CAtlHttpClient;					// HTTPNCAgIuWFNg쐬
		clsNavData.SetReadStatusCallback( HttpNavCallback , (DWORD_PTR)pclsPopupMon );
		clsNavData.SetChunkCallback     ( HttpChunkCallback , (DWORD_PTR)pclsPopupMon );

		PCGAITAMEMON_PARAM pudtParm = pclsPopupMon->m_pclsFrame->GetParameter ();
		if (pudtParm->m_enmUseProxy != GAITAMEMON_PROXY_USE_NONE) {
			switch (pudtParm->m_enmUseProxy) {
			case GAITAMEMON_PROXY_USE_IE:
                pclsHttpClient->SetProxy ( NULL , 0 );						//IEw
				break;
			case GAITAMEMON_PROXY_USE_SET:
                pclsHttpClient->SetProxy ( pudtParm->m_strProxyServer  , pudtParm->m_intProxyPort );
			}
			basicAuth.SetUserPass ( pudtParm->m_strProxyUserID , pudtParm->m_strProxyPassword ); // USERIDPASSݒ
			pclsHttpClient->AddAuthObj( _T("BASIC"), &basicAuth, &basicAuth );                  // F؃IuWFNgǉ
		}
		else {																// vLVwȂ
			pclsHttpClient->SetProxy ( "" , 0 );
		}
		if (pclsHttpClient->Navigate( &pclsPopupMon->m_clsTargetURL , &clsNavData ))
		{
			CString strHttpDateTime;

			pclsPopupMon->m_strOwnMessage.Empty ();
			pclsHttpClient->GetHeaderValue( _T("Date"), strHttpDateTime );		// HTTPwb_[t/擾

			if (pclsHttpClient->GetStatus() == 200) // 200 = successful HTTP transaction
			{
				CString strBody;
				CString strDisplay;

				pclsPopupMon->m_pclsFrame->SetTrayIcon2 ( AtlLoadIcon(IDR_MAINFRAME));
				long  bodyLen = pclsHttpClient->GetBodyLength();
				strBody.SetString ((PCTSTR)pclsHttpClient->GetBody() , bodyLen ); 

				if (strBody.Mid(11,8) == _T("ăh~")) {                             //?
					CXMutexLock clsLock(_T("GaitameMutexLock"),TRUE);							//ACeGÃbN
					pclsPopupMon->m_clsRateItems.LoadItems ( strHttpDateTime , strBody.Mid(11));			 // 񕪉
					clsLock.Unlock ();															//ACeGÃbN
					::PostMessage ( pclsPopupMon->m_hWnd , WM_FORCE_UPDATE ,0,0);        //ʍXV
				}
			}
			else {
				pclsPopupMon->m_pclsFrame->SetTrayIcon2 ( AtlLoadIcon(IDR_MAINFRAME_ERROR));
				str.Format( _T("ڑG[ : %d\r\n"), pclsHttpClient->GetStatus() );
				pclsPopupMon->m_pclsFrame->OnDisplayInfoTips ( str , NIIF_ERROR);              // G[\
			}
		}
		else {														//G[
			DWORD dwSockRC;
			DWORD dwSize;
			LPVOID pchError;
			int   intHttpCode;
			
			pclsPopupMon->m_pclsFrame->SetTrayIcon2 ( AtlLoadIcon(IDR_MAINFRAME_ERROR));
			CAtlHttpClient::HTTP_RESPONSE_READ_STATUS enmRC = pclsHttpClient->GetResponseStatus();
			switch ( enmRC ) {
			case CAtlHttpClient::RR_OK:                                       //?F؃G[
			case CAtlHttpClient::RR_READSOCKET_FAILED:                        //?SocketError
			case CAtlHttpClient::RR_NOT_READ:
				dwSockRC = pclsHttpClient->GetLastError();
				switch (dwSockRC ) {
				case 0:														//?\PbgG[Ȃ
					intHttpCode = pclsHttpClient->GetStatus();
					switch ( intHttpCode ) {
					case 407:
						str.Format ( _T("ProxyF؃G[\nProxy[UID,pX[hw肵Ă"));
						break;
					default:
						str.Format ( _T("ڑG[ : %d"), intHttpCode );
						break;
					}
					break;
				case WAIT_TIMEOUT:											//ANZX^CAEg
					str.Format( _T("ڑ^CAEgł : %s"), pclsPopupMon->m_clsTargetURL.GetHostName() );
					break;
				case ERROR_IO_PENDING:                                      // IO
					break;
				default: 
					dwSize = FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
											NULL,
											dwSockRC,
											MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
											(LPTSTR)&pchError,
											0,
											NULL );
					memcpy ( str.GetBufferSetLength (dwSize),pchError,dwSize);
					str.ReleaseBuffer ();
					LocalFree ( pchError );
					str.AppendFormat ( _T(",RC=%d,zXg=%s"),dwSockRC,pclsPopupMon->m_clsTargetURL.GetHostName());  
					break;
				}
				break;
			case CAtlHttpClient::RR_STATUS_INVALID:
				str = _T("Xe[^X C̉͂Ɏs܂");
				break;
			case CAtlHttpClient::RR_PARSEHEADERS_FAILED:
				str = _T("HTTP wb_[̉͒ɃG[܂");
				break;
			case CAtlHttpClient::RR_READBODY_FAILED:
				str = _T("{̂̑Ŝ̓ǂݎɎs܂");
				break;
			case CAtlHttpClient::RR_READCHUNKEDBODY_FAILED:
				str = _T("`N]GR[hꂽ̓ǂݎɎs܂");
				break;
			default:
				str.Format(_T("m̃Xe[^X(%d)") , enmRC );
				break;
			}
			pclsPopupMon->m_pclsFrame->OnDisplayInfoTips ( str , NIIF_ERROR );              // G[\
		}
		delete pclsHttpClient;
		pclsHttpClient = NULL;
		pclsPopupMon->m_HttpAccessInProgress = FALSE;
		return 0;
	}
	//---- {^NbN ------------------
	//  tH[JX擾AʂOʂɈړ
	LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM lngKeyStatus , LPARAM lParam , BOOL& bHandled)
	{
		CRect  clsDateRect;

		SetForegroundWindow( *this );
		ShowWindow (SW_SHOW );
		if (( lngKeyStatus & MK_SHIFT ) && ( lngKeyStatus & MK_CONTROL )) {		//?SHIFT + CTRLKEY
			CPoint  clsMousePos ( LOWORD(lParam) , HIWORD(lParam) );
			TrackMouse ( clsMousePos );						//EBhEړ
		}
		return 0;
	}
	//---- {^Abv ------------------
	LRESULT OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled)
	{
		return 0;
	}
	//---- }EXړ ------------------
	LRESULT OnMouseMove (UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		return 0;
	}
	LRESULT OnEraseBackGround(UINT /*uMsg*/, WPARAM wParam , LPARAM /* lParam */, BOOL& bHandled)
	{
		bHandled = TRUE;
		return 0;   
	}
	//
	// WM_PAINT
	//
	LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled )
	{
        CPaintDC clsWinDC(*this);
		CRect    clsRect,clsRectOrg;
		CString  strDisplay;
		CBitmap  clsBitmap;
		HBITMAP  hSavedBitmap;
		CDC	clsDC;											//h~̃foCXReLXg
		CRect  clsDateRect;                                 //tlp`
	
		GetClientRect ( &clsRect );
		clsRectOrg = clsRect;
		clsRect.bottom = mlngPoopupWindowHeight;
		clsRect.NormalizeRect();

		clsDC.CreateCompatibleDC(clsWinDC);
		clsBitmap.CreateCompatibleBitmap (clsWinDC , clsRect.Width() , clsRect.Height() );
		hSavedBitmap = clsDC.SelectBitmap ( clsBitmap );     // fBXNgbvTCỸrbg}bv쐬 dc Ɋ蓖

		clsDC.FillRect ( &clsRect , m_clsColorBodyBack );             //wiF
		HFONT hFontOld = clsDC.SelectFont(m_clsFont);
		clsDC.SetBkMode(TRANSPARENT);
		clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorBodyText );

		clsDC.SetTextAlign(TA_TOP | TA_NOUPDATECP);

		clsDateRect = clsRect;
		clsDateRect.bottom = clsRect.top + m_clsCharSize.cy * m_intDateRowCount;
		clsDC.FillRect ( &clsDateRect , m_clsColorDateBack );             //twiF
		clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorDateText );							//tF		

		if (m_strOwnMessage.GetLength() > 0 ) {
			clsDC.DrawText ( m_strOwnMessage , -1 , clsRect , DT_WORDBREAK );
		}
		else {
			int y;
			ClockTable tblClock;
			CString strClock;
			CRect   clsRateBGRect;

			y = clsRect.top;
																					// t\
			CXMutexLock clsLock(_T("GaitameMutexLock"),TRUE);							//ACeGÃbN
			for ( size_t i = 0 ; i < m_clsRateItems.gtblClock.GetCount() ; i++ ) {
				tblClock = m_clsRateItems.gtblClock[i];
				strClock = tblClock.clsCurrentTime.Format ( _T("%Y/%m/%d %H:%M:%S") );
				strDisplay.Format (_T("%-*.*s %s") , m_clsRateItems.gintClockCaptionMax , m_clsRateItems.gintClockCaptionMax ,
														tblClock.strName , strClock );
				clsDC.TextOut ( clsRect.left , y ,  (LPCTSTR)strDisplay);
				y += m_clsCharSize.cy;
			}

			clsRateBGRect = clsRect;
			clsRateBGRect.top = y;
			clsRateBGRect.bottom = y + m_clsCharSize.cy ;
			clsDC.FillRect ( &clsRateBGRect , m_clsColorHeaderBack );				//wiF
			clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorHeaderText );							//F		
			clsDC.TextOut ( clsRect.left , y ,  _T("                  Bid    Ask   BidHi  BidLow Change") );
			y += m_clsCharSize.cy;

			clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorBodyText );							//F		
			for (int i = 0 ; i < m_clsRateItems.gintCount ; i++ ) {
				if (m_pclsFrame->GetParameter()->m_blnRateDisplay[i]) {
					clsRateBGRect = clsRect;
					clsRateBGRect.top = y;
					clsRateBGRect.bottom = y + m_clsCharSize.cy;
					if (m_pclsFrame->GetParameter()->m_blnRateChangeIndicate) {								//?RateύXF\
						switch ( m_clsRateItems.gtblItems[i].gintBidDifference) {
						case 1:														//オ
							clsDC.FillRect ( &clsRateBGRect , m_clsColorRateUpBack );				//wiF
							clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorRateUpText );							//F		
							break;
						case -1:													//
							clsDC.FillRect ( &clsRateBGRect , m_clsColorRateDownBack );             //wiF
							clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorRateDownText );						//F		
							break;
						default:
							clsDC.SetTextColor ( m_pclsFrame->GetParameter()->m_ColorBodyText );							//F		
							break;
						}
					}

					GetRateDisplayString ( strDisplay , i );

					clsDC.TextOut (clsRect.left , y , strDisplay );
					y += m_clsCharSize.cy;
				}
			}
			clsLock.Unlock();
		}

		clsRect = clsRectOrg;
		if (!m_pclsFrame->GetParameter()->m_blnUseColorKey ) {						//?߃J[L[wȂ
			clsWinDC.DrawEdge ( &clsRect , EDGE_SUNKEN , BF_ADJUST | BF_RECT );		//Og̕` clsRectXV
		}
		else {
			clsRect.DeflateRect ( CSize(2,2) );
		}
		switch (m_pclsFrame->GetParameter()->m_enmPopupGrow) {
		case POPUP_GROW_DIR_BOTTOM_TO_TOP:								//
			clsWinDC.BitBlt( clsRect.left , clsRect.top , clsRect.Width() , clsRect.Height(),clsDC,0,0,SRCCOPY);
			break;
		case POPUP_GROW_DIR_TOP_TO_BOTTOM:								//ォ牺
			clsWinDC.BitBlt( clsRect.left , clsRect.top ,clsRect.Width() , clsRect.Height(),clsDC,0,mlngPoopupWindowHeight-clsRectOrg.Height(),SRCCOPY);
			break;
		}

		clsDC.SelectFont(hFontOld);
		clsDC.SelectBitmap (hSavedBitmap);
		bHandled = TRUE;
		return 0;
	}
	//
	//   \쐬
	//
	void GetRateDisplayString ( CString & strDisplay , int intIndex ) 
	{
		CString strCurBid;
		CString strCurAsk;
		PCHAR   pFlagSign;

		switch ( intIndex )
		{
		case RATEITEM_EURUSD:									//[h
		case RATEITEM_GBPUSD:									//|hh
		case RATEITEM_USDCHF:									//hXCX_ȉS
			strCurBid = m_clsRateItems.gtblItems[intIndex].gcurBid.Format ( FALSE , 1 , 4 );
			strCurAsk = m_clsRateItems.gtblItems[intIndex].gcurAsk.Format ( FALSE , 1 , 4 );
			break;
		default:
			strCurBid = m_clsRateItems.gtblItems[intIndex].gcurBid.Format ( FALSE , 3 , 2 );
			strCurAsk = m_clsRateItems.gtblItems[intIndex].gcurAsk.Format ( FALSE , 3 , 2 );
			break;
		}
		
		switch ( m_clsRateItems.gtblItems[intIndex].gintBidDifference) {
		case 1:														//オ
			pFlagSign = _T("");
			break;
		case -1:
			pFlagSign = _T("");
			break;
		default:
			pFlagSign = _T("");
			break;
		}
		strDisplay.Format ( _T("%-13s:%2s%6s-%6s %6s %6s %6s"), 
				m_clsRateItems.gtblItems[intIndex].gstrName ,
				pFlagSign ,
				strCurBid  ,
				strCurAsk  ,
				m_clsRateItems.gtblItems[intIndex].gstrBidHi   ,
				m_clsRateItems.gtblItems[intIndex].gstrBidLow  ,
				m_clsRateItems.gtblItems[intIndex].gstrChange  
				);
	}
	//-------------------------------------------------------------------------------------------
	// @[gXV
	//-------------------------------------------------------------------------------------------
	LRESULT OnForceUpdate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled )
	{
		CString strDisplay;
		if (m_pclsFrame->GetParameter()->m_enmRateDisplayTipsIndex < RATEITEM_COUNTS ) {
			GetRateDisplayString ( strDisplay , m_pclsFrame->GetParameter()->m_enmRateDisplayTipsIndex );
			m_pclsFrame->OnDisplayTips ( strDisplay );					//c[`bvXV
		}
		InvalidateRect(NULL);
		UpdateWindow ( );

		CheckLimit();													//~bg`FbN

		return 0;
	}
	//----------------------------------------------------------------------
	// ~bg`FbN
	//----------------------------------------------------------------------
	void CheckLimit()
	{
		BOOL					blnHit;
		PCGAITAMEMON_PARAM		ptblParam;
		int						intHitUnitIndex;
		int						intHitIndex;
		CTime					clsHitTime;
		CXCurrency				curHitCurrency;

		clsHitTime = CTime::GetCurrentTime ();

		ptblParam = m_pclsFrame->GetParameter();
		blnHit = FALSE;
		for ( int intUNITIndex = 0 ; intUNITIndex < RATEITEM_COUNTS ; intUNITIndex++ ) {
			for ( int intIndex = 0 ; intIndex < LIMIT_INDEX_COUNT ; intIndex++ ) {
				if ( ptblParam->m_blnLimitEnabled[intUNITIndex][intIndex] ) {			//?~bgݒ
					CXCurrency curParmBid;
					curParmBid= ptblParam->m_curLimit[intUNITIndex][intIndex][LIMIT_BIDASK_BID];
					if (curParmBid.IsEnabled() ) {										      //?L
						if ( m_clsRateItems.gtblItems[intUNITIndex].gcurBid <= curParmBid ) { //?B
							ptblParam->m_blnLimitEnabled[intUNITIndex][intIndex] = FALSE;
							ptblParam->m_strLimitStatus[intUNITIndex][intIndex] = GetHitTextForRow (clsHitTime ,intUNITIndex,curParmBid , _T("(l)") );
							if (!blnHit) {
								intHitUnitIndex = intUNITIndex;
								intHitIndex     = intIndex;
								curHitCurrency  = curParmBid;
							}
							blnHit = TRUE;
						}
					}
					CXCurrency curParmAsk;
					curParmAsk= ptblParam->m_curLimit[intUNITIndex][intIndex][LIMIT_BIDASK_ASK];
					if (curParmAsk.IsEnabled() ) {										      //?L
						if ( m_clsRateItems.gtblItems[intUNITIndex].gcurAsk >= curParmAsk ) { //?B
							ptblParam->m_blnLimitEnabled[intUNITIndex][intIndex] = FALSE;
							ptblParam->m_strLimitStatus[intUNITIndex][intIndex] = GetHitTextForRow (clsHitTime,intUNITIndex,curParmAsk , _T("(l)") );
							if (!blnHit) {
								intHitUnitIndex = intUNITIndex;
								intHitIndex     = intIndex;
								curHitCurrency  = curParmAsk;
							}
							blnHit = TRUE;
						}
					}
				}
			}
		}
		if (blnHit) {											//?qbg
			if (ptblParam->m_blnLimitHitSound ) {				//TEh
				PlaySound ( ptblParam->m_strLimitHitSoundFile , NULL , SND_FILENAME | SND_ASYNC );
			}
			switch (ptblParam->m_enmLimitHitAction ) {
			case LIMIT_HIT_ACTION_SHELL:
				if ( ptblParam->m_strLimitHitShell.GetAllocLength () > 0 ) {     //?VF񂠂
					::ShellExecute ( NULL , 
						NULL ,
						(LPCTSTR)ptblParam->m_strLimitHitShell ,
						 GetFormatHitText ( ptblParam->m_strLimitHitShellCommandLine , clsHitTime , intHitUnitIndex , intHitIndex , curHitCurrency ) ,					 
						NULL ,
						SW_SHOWNORMAL );
				}
				break;
			case LIMIT_HIT_ACTION_TIPS:											//?c[`bv
				{
					CString strTitle;
					CString strString;
					strTitle  = ( ptblParam->m_strLimitHitShell.GetLength () > 0            ) ? ptblParam->m_strLimitHitShell            : _T("O׃ qbg!");
					strString = ( ptblParam->m_strLimitHitShellCommandLine.GetLength () > 0 ) ?
						 GetFormatHitText ( ptblParam->m_strLimitHitShellCommandLine , clsHitTime , intHitUnitIndex , intHitIndex , curHitCurrency )						 
						 : 
					GetFormatHitText ( _T("{M}/{D} {H}:{N}:{S} {U}{V}ɓB܂") , clsHitTime , intHitUnitIndex , intHitIndex , curHitCurrency );
					m_pclsFrame->OnDisplayInfoTipsOnHit ( strTitle , strString );
				}
				break;
			}
		}
	}
	//
	//  sҏW
	//
    const CString GetHitTextForRow (
										CTime		&clsCurrentClock ,      //
										INT			intUNITIndex ,			//
										CXCurrency	&curParam ,				//B[g
										LPCTSTR		strAddingString			//ǉ
										) {
		CString strDisplay;
		int     intInteger;
		int     intFraction;
		
		switch ( intUNITIndex ) {
		case RATEITEM_EURUSD:
		case RATEITEM_GBPUSD:
		case RATEITEM_USDCHF:
			intInteger = 1;
			intFraction = 4;
			break;
		default:
			intInteger  = 3;
			intFraction = 2;
			break;
		}
		strDisplay.Format ( _T("%02d/%02d %02d:%02d %sɓB܂" ),
			clsCurrentClock.GetMonth () , clsCurrentClock.GetDay () , clsCurrentClock.GetHour () , clsCurrentClock.GetMinute () ,
			(LPCTSTR)curParam.Format ( FALSE , intInteger , intFraction ) ,
			strAddingString );
		return  strDisplay;
	}
	//
	// qbgeLXg쐬
	//
	const CString GetFormatHitText (
										LPCTSTR     pstrFormat ,			//
										CTime		&clsCurrentTime ,		//
										int			intHitUnitIndex ,		//jbg
										int			intHitIndex ,			//CfbNX
										CXCurrency	&curParam  				//B[g
									) {
	
		CString strDisplay;
		int     intInteger;
		int     intFraction;
		
		switch ( intHitUnitIndex ) {
		case RATEITEM_EURUSD:
		case RATEITEM_GBPUSD:
		case RATEITEM_USDCHF:
			intInteger = 1;
			intFraction = 4;
			break;
		default:
			intInteger  = 3;
			intFraction = 2;
			break;
		}

		LPCTSTR   pstrPosFmt;
		BOOL      blnInFormat;
		blnInFormat = FALSE;
		pstrPosFmt = pstrFormat;
		while ( *pstrPosFmt ) {
			if (blnInFormat) {							//?̒
				switch (*pstrPosFmt) {
				case '{':								//? {
					blnInFormat = FALSE;
					strDisplay.AppendChar ( '{' );
					break;
				case '}':								//? } I
					blnInFormat = FALSE;
					break;
				case 'Y':								//? 2
					strDisplay.AppendFormat ( _T("%02d") , clsCurrentTime.GetYear() );
					break;
				case 'y':								//? 4
					strDisplay.AppendFormat ( _T("%04d") , clsCurrentTime.GetYear() );
					break;
				case 'M':								//
					strDisplay.AppendFormat ( _T("%02d") , clsCurrentTime.GetMonth() );
					break;
				case 'D':								//
					strDisplay.AppendFormat ( _T("%02d") , clsCurrentTime.GetDay() );
					break;
				case 'H':								//
					strDisplay.AppendFormat ( _T("%02d") , clsCurrentTime.GetHour() );
					break;
				case 'N':								//
					strDisplay.AppendFormat ( _T("%02d") , clsCurrentTime.GetMinute() );
					break;
				case 'S':								//b
					strDisplay.AppendFormat ( _T("%02d") , clsCurrentTime.GetSecond() );
					break;
				case 'U':								//jbg
					strDisplay.AppendFormat ( _T("%s") ,gstrtblRateItem[intHitUnitIndex] );
					break;
				case 'V':								//l
					strDisplay.AppendFormat ( _T("%s") , (LPCTSTR)curParam.Format ( FALSE , intInteger , intFraction ) );
					break;
				case 'I':								//Bid/Ask
					strDisplay.AppendFormat ( _T("%s") , (intHitIndex == LIMIT_BIDASK_BID) ? _T("l") : _T("l") );
					break;
				case 'i':								//Bid/Ask
					strDisplay.AppendFormat ( _T("%s") , (intHitIndex == LIMIT_BIDASK_BID) ? _T("Bid") : _T("Ask") );
					break;
				default:
					break;
				}
			}
			else {										//?̊O
				if (*pstrPosFmt == '{') {				//?Jn
					blnInFormat = TRUE;
				}	
				else {									//ʏ핶
					strDisplay.Append ( pstrPosFmt , _tcsnbcnt ( pstrPosFmt , 1 ) );
				}
			}
			pstrPosFmt = _tcsinc ( pstrPosFmt );
		}
		return  strDisplay;

	}
/****************************************************************************
 *                                                                          *
 *  FUNCTION   : TrackMouse(HWND hwnd, POINT pt)                            *
 *                                                                          *
 *  PURPOSE    : Draws a rubberbanding rectangle and displays it's          *
 *               dimensions till the mouse button is released               *
 *                                                                          *
 ****************************************************************************/
	VOID TrackMouse (CPoint &pt )
	{
		MSG   msg;
		CPoint _ptCurrentPos;
		CRect rcWindow;

		SetCapture();

		for (;;){
			WaitMessage();
			if (PeekMessage(&msg,NULL,WM_MOUSEFIRST,WM_MOUSELAST,PM_REMOVE)){
				_ptCurrentPos.SetPoint ( GET_X_LPARAM(msg.lParam) , GET_Y_LPARAM(msg.lParam) );
				GetWindowRect(&rcWindow);
				rcWindow += _ptCurrentPos - pt;
				rcWindow.NormalizeRect();
				MoveWindow ( rcWindow );
				if (msg.message == WM_LBUTTONUP) {
					break;
				}
			}
			else {
//				if(!PreTranslateMessage(&msg)) {
//					::TranslateMessage(&msg);
//					::DispatchMessage(&msg);
//				}
			}
		}

		ReleaseCapture();
	}
};
