#pragma once
#include <strsafe.h>
// CXTaskTray.h : wb_[ t@C
//
//------------ VXegCNX ------------------------
//
//   gp@:
//   class CMainFrame : .....
//   		public CXTaskTrayImpl <CMainFrame>
//    {
//    public:
//
//        BEGIN_MSG_MAP(CMainFrame)
//		  CHAIN_MSG_MAP(CXTaskTrayImpl<CMainFrame>)        // VXegC
//
// stdafx.h _WIN32_IE  0x0500 ȏɐݒ肷
//
//
//#define ARRAYSIZE(a) (sizeof(a)/sizeof(a[0]))

template <typename Deriving>
class CXTaskTrayImpl
{
public:
	BEGIN_MSG_MAP(CXTaskTrayImpl<Deriving>)
	MESSAGE_HANDLER( m_uTrayActionMessage	, OnTrayIcon )
	MESSAGE_HANDLER( m_uTaskbarRestart		, OnTaskbarRestart )
	END_MSG_MAP()
protected:
	enum INFO_FLAG {
		INFO_WARNING = NIIF_WARNING,
		INFO_ERROR   = NIIF_ERROR,
		INFO_INFO    = NIIF_INFO
	};

private:
	UINT	m_uTrayActionMessage;								//gCActionbZ[W
	BOOL	m_blnAdded;
	HWND	m_hBaseWindow;										// eʂ̃EBhEnh(ۑ)
	UINT	m_uTaskbarRestart;									//^XNo[č쐬bZ[W

	//===================================================================================================
	//
	//===================================================================================================
public:
	//  RXgN^
	CXTaskTrayImpl ()
	{
		m_blnAdded = FALSE;
		m_uTrayActionMessage = RegisterWindowMessage ( _T("CXTaskTrayImpl::SystemTrayAction") );	//bZ[W̍쐬
        m_uTaskbarRestart    = RegisterWindowMessage ( _T("TaskbarCreated") );						//^XNo[č쐬bZ[W
	}
	// j
	virtual ~CXTaskTrayImpl ()
	{
		DeleteTray();
	}

private:
	//
	// NOTIFYICONDATȀ
	//
	void InitalizeBaseParameter ( NOTIFYICONDATA &udtData )
	{
		ZeroMemory ( &udtData , sizeof(NOTIFYICONDATA));
		udtData.cbSize = NOTIFYICONDATA_V2_SIZE; //sizeof (NOTIFYICONDATA);
		udtData.hWnd = m_hBaseWindow; 
		udtData.uID = 1;
	}
protected:
	//
	//  gCACR̍쐬
	//
	BOOL CreateTray( )
	{
		m_hBaseWindow = static_cast<Deriving *>(this)->m_hWnd;
		return TRUE;
	}
	//
	//  gCACR폜
	//
	BOOL DeleteTray()
	{
		NOTIFYICONDATA udtData;
		InitalizeBaseParameter ( udtData );
		if (m_blnAdded) {
			Shell_NotifyIcon ( NIM_DELETE, &udtData );
			m_blnAdded = FALSE;
		}
		return TRUE;
	}
	//
	//  gCACRǉ
	//
	BOOL AddTray( )
	{
		NOTIFYICONDATA udtData;
		InitalizeBaseParameter ( udtData );

		if (!m_blnAdded ) {				// VKǉ?
			udtData.cbSize = NOTIFYICONDATA_V2_SIZE; //sizeof (NOTIFYICONDATA);
			udtData.hWnd = static_cast<Deriving *>(this)->m_hWnd; 
			udtData.uID = 1;
			udtData.uFlags = NIF_MESSAGE ;
			udtData.uCallbackMessage = m_uTrayActionMessage;
			m_blnAdded = TRUE;
			if (!Shell_NotifyIcon ( NIM_ADD , &udtData )) {
				return FALSE;
			}
		}
		return TRUE;
	}
	//
	// gCACR̃ACRƃc[`bv̐ݒ
	//
	void SetTrayIcon( HICON hIcon , LPCTSTR strTips  = NULL )
	{
		NOTIFYICONDATA udtData;
		InitalizeBaseParameter ( udtData );

		udtData.uFlags = 0;
		if ( strTips != NULL ) {                      // c[`bv̐ݒH
			StringCchCopy(udtData.szTip, ARRAYSIZE(udtData.szTip), strTips);
			udtData.uFlags |= NIF_TIP;
		}
		if ( hIcon != NULL ) {						 // ACR̐ݒH
			udtData.hIcon = hIcon;
			udtData.uFlags |= NIF_ICON;
		}
	//	udtData.uFlags |= NIF_INFO;
		udtData.szInfo[0] = '\0';
		Shell_NotifyIcon ( NIM_MODIFY , &udtData );
	}
	//
	// gCACR̃CtH`bv\(Windows2000ȍ~)
	//
	void SetInfoTips(LPCTSTR strInfo , LPCTSTR strTitle  = NULL, DWORD enmFlag = INFO_INFO , UINT uTimeOut = 10000 )
	{
		NOTIFYICONDATA udtData;
		InitalizeBaseParameter ( udtData );
		StringCchCopy(udtData.szInfo, ARRAYSIZE(udtData.szInfo), strInfo);
		if ( strTitle != NULL ) {										// ^Cg̎w肠?
			StringCchCopy(udtData.szInfoTitle, ARRAYSIZE(udtData.szInfoTitle), strTitle);
		}
		udtData.dwInfoFlags  = enmFlag;
		udtData.uFlags       = NIF_INFO;
		udtData.uTimeout     = uTimeOut ;									// in milliseconds
		Shell_NotifyIcon ( NIM_MODIFY , &udtData );
	}
private:
	//
	//  gCACRł̃ANV
	//
	LRESULT OnTrayIcon (UINT nMsg , WPARAM wParam , LPARAM lParam  ,BOOL &bHandled )
	{
		POINT oPos;
		::GetCursorPos ( &oPos );             // ݂̃J[\ʒu擾
		switch ( lParam ) {
		case WM_RBUTTONUP:                          // }EXE{^
			if ( OnTrayIcon_MouseRButtonUp( oPos ) ) {
				static_cast<Deriving *>(this)->PostMessage(WM_NULL, 0L, 0L);       //܂Ȃ炵
			}
			break;
		case WM_LBUTTONUP:							// }EX{^
			if (OnTrayIcon_MouseLButtonUp( oPos ) ) {
				static_cast<Deriving *>(this)->PostMessage(WM_NULL, 0L, 0L);       //܂Ȃ炵
			}
			break;
		case WM_LBUTTONDOWN:						// }EX{^
			if (OnTrayIcon_MouseLButtonDown( oPos ) ) {
				static_cast<Deriving *>(this)->PostMessage(WM_NULL, 0L, 0L);       //܂Ȃ炵
			}
			break;
		case WM_LBUTTONDBLCLK:                      //}EX_uNbN
			if (OnTrayIcon_MouseLButtonDblClick( oPos ) ) {
				static_cast<Deriving *>(this)->PostMessage(WM_NULL, 0L, 0L);       //܂Ȃ炵
			}
			break;

		}
		return TRUE;      // ȏチbZ[W͍sȂ
	}
	//
	//  ^XNgCč쐬
	//
	LRESULT OnTaskbarRestart (UINT nMsg , WPARAM wParam , LPARAM lParam  ,BOOL &bHandled )
	{
		DeleteTray();																//gC폜͂܂
		OnTrayIcon_TaskbarRestart ();                                               //č쐬
		return TRUE;
	}
protected:
	//
	// gCACR̃}EXENbNAbv
	//    |bvAbvbZ[W\́ATRUEŖ߂
	//
	virtual LRESULT OnTrayIcon_MouseRButtonUp ( POINT &oPos )
	{
	//		SetForegroundWindow();
	//		cPopup->TrackPopupMenu( TPM_RIGHTBUTTON | TPM_RIGHTALIGN  | TPM_BOTTOMALIGN  , cPos.x, cPos.y , this );
		return FALSE;
	}
	// gCACR̃}EXNbNAbv
	//    |bvAbvbZ[W\́ATRUEŖ߂
	//
	virtual LRESULT OnTrayIcon_MouseLButtonUp ( POINT &oPos )
	{
		return FALSE;
	}
	// gCACR̃}EXNbN_E
	virtual LRESULT OnTrayIcon_MouseLButtonDown ( POINT &oPos )
	{
		return FALSE;
	}
	// gCACR̃}EX_uNbN
	virtual LRESULT OnTrayIcon_MouseLButtonDblClick ( POINT &oPos )
	{
		return FALSE;
	}
	// gCACRĕ\(K)
	virtual void OnTrayIcon_TaskbarRestart ( ) = 0;
};