#pragma once
//
//   Mutex Lock @\
//
class CXMutexLock
{
private:
	HANDLE  m_hObject;
	BOOL    m_Lock;
public:
	operator HANDLE() const;
public:
	//  \z
	//       pstrName : ʖ
	//
	CXMutexLock()
	{
		m_hObject = NULL;
		m_Lock = FALSE;
	}
	CXMutexLock(LPCTSTR pstrName ,BOOL blnInitialLock = FALSE,DWORD dwTimeout = INFINITE) 
	{
		m_hObject = NULL;
		m_Lock = FALSE;
		ATLASSERT (Create (pstrName , blnInitialLock ,dwTimeout) );
	}
	//  j
	//
	//
	virtual ~CXMutexLock()
	{
		if (m_hObject) {
			if (m_Lock) {
				Unlock();
			}
			::CloseHandle(m_hObject);
			m_hObject = NULL;
		}
	}
	// MutexIuWFNg쐬
	//       pstrName       : ʖ
	//       blnInitialLock : 쐬bN(True)
	BOOL Create (LPCTSTR pstrName = NULL , BOOL blnInitialLock = FALSE,DWORD dwTimeout = INFINITE)
	{
		ATLASSERT ( m_hObject == NULL );
		m_hObject = ::CreateMutex ( NULL , FALSE , pstrName );
		if (m_hObject == NULL) {
			return FALSE;
		}
		if ( blnInitialLock ) {
			return Lock ( dwTimeout );
		}
		return TRUE;
	}
	// Mutex bN
	//       dwTimeout : ^CAEgl
	//
	BOOL Lock(DWORD dwTimeout = INFINITE)
	{
		ATLASSERT ( m_hObject );
		if (::WaitForSingleObject(m_hObject, dwTimeout) == WAIT_OBJECT_0) {
			m_Lock = TRUE;
			return TRUE;
		}
		else {
			return FALSE;
		}
	}
	// Mutex AbN
	//
	//
	BOOL Unlock()
	{
		ATLASSERT ( m_hObject );
		return ::ReleaseMutex ( m_hObject );
		m_Lock = FALSE;
	}
};
